Package org.apache.coyote.http11.filters

## Class BufferedInputFilter

- java.lang.Object
- - org.apache.coyote.http11.filters.BufferedInputFilter

All Implemented Interfaces:
  `InputFilter`, `InputBuffer`, `ApplicationBufferHandler`

    public class BufferedInputFilter
    extends java.lang.Object
    implements InputFilter, ApplicationBufferHandler

Input filter responsible for reading and buffering the request body, so that it does not interfere with client SSL handshake messages.

### Field Summary

### Fields inherited from interface org.apache.tomcat.util.net.ApplicationBufferHandler

`EMPTY, EMPTY_BUFFER`

### Constructor Summary

Constructors
`BufferedInputFilter​(int maxSwallowSize)`

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `available()` Obtain an estimate of the number of bytes that can be read without blocking.
`int` `doRead​(ApplicationBufferHandler handler)` Fills the given ByteBuffer with the buffered request body.
`long` `end()` End the current request.
`void` `expand​(int size)`
`java.nio.ByteBuffer` `getByteBuffer()`
`ByteChunk` `getEncodingName()` Get the name of the encoding handled by this filter.
`boolean` `isFinished()` Has the request body been read fully?
`void` `recycle()` Make the filter ready to process the next request.
`void` `setBuffer​(InputBuffer buffer)` Set the next buffer in the filter pipeline.
`void` `setByteBuffer​(java.nio.ByteBuffer buffer)`
`void` `setLimit​(int limit)` Set the buffering limit.
`void` `setRequest​(Request request)` Reads the request body and buffers it.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### BufferedInputFilter

    public BufferedInputFilter​(int maxSwallowSize)

### Method Detail

#### setLimit

    public void setLimit​(int limit)

Set the buffering limit. This should be reset every time the buffer is used.

Parameters:
  `limit` - The maximum number of bytes that will be buffered

#### setRequest

    public void setRequest​(Request request)

Reads the request body and buffers it.

Specified by:
  `setRequest` in interface `InputFilter`
Parameters:
  `request` - The request to be associated with this filter

#### doRead

    public int doRead​(ApplicationBufferHandler handler)
               throws java.io.IOException

Fills the given ByteBuffer with the buffered request body.

Specified by:
  `doRead` in interface `InputBuffer`
Parameters:
  `handler` - ApplicationBufferHandler that provides the buffer to read data into.
Returns:
  The number of bytes that have been added to the buffer or -1 for end of stream
Throws:
  `java.io.IOException` - If an I/O error occurs reading from the input stream

#### setBuffer

    public void setBuffer​(InputBuffer buffer)

Description copied from interface: `InputFilter`
Set the next buffer in the filter pipeline.

Specified by:
  `setBuffer` in interface `InputFilter`
Parameters:
  `buffer` - The next buffer

#### recycle

    public void recycle()

Description copied from interface: `InputFilter`
Make the filter ready to process the next request.

Specified by:
  `recycle` in interface `InputFilter`

#### getEncodingName

    public ByteChunk getEncodingName()

Description copied from interface: `InputFilter`
Get the name of the encoding handled by this filter.

Specified by:
  `getEncodingName` in interface `InputFilter`
Returns:
  The encoding name as a byte chunk to facilitate comparison with the value read from the HTTP headers which will also be a ByteChunk

#### end

    public long end()
             throws java.io.IOException

Description copied from interface: `InputFilter`
End the current request.

Specified by:
  `end` in interface `InputFilter`
Returns:
  0 is the expected return value. A positive value indicates that too many bytes were read. This method is allowed to use buffer.doRead to consume extra bytes. The result of this method can't be negative (if an error happens, an IOException should be thrown instead).
Throws:
  `java.io.IOException` - If an error happens

#### available

    public int available()

Description copied from interface: `InputBuffer`
Obtain an estimate of the number of bytes that can be read without blocking. Typically, this will be the number of available bytes known to be buffered.

Specified by:
  `available` in interface `InputBuffer`
Returns:
  The number of bytes that can be read without blocking

#### isFinished

    public boolean isFinished()

Description copied from interface: `InputFilter`
Has the request body been read fully?

Specified by:
  `isFinished` in interface `InputFilter`
Returns:
  `true` if the request body has been fully read, otherwise `false`

#### setByteBuffer

    public void setByteBuffer​(java.nio.ByteBuffer buffer)

Specified by:
  `setByteBuffer` in interface `ApplicationBufferHandler`

#### getByteBuffer

    public java.nio.ByteBuffer getByteBuffer()

Specified by:
  `getByteBuffer` in interface `ApplicationBufferHandler`

#### expand

    public void expand​(int size)

Specified by:
  `expand` in interface `ApplicationBufferHandler`